with Interfaces; use Interfaces;

package body CORBA_Repository_Root_Contained_Hash is

   P : constant array (0 .. 3) of Natural :=
     (2, 4, 6, 9);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (2, 4, 16, 27);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (25, 1, 18, 25);

   G : constant array (0 .. 36) of Unsigned_8 :=
     (12, 0, 6, 0, 0, 16, 0, 0, 0, 17, 11, 17, 0, 0, 0, 0, 0, 0, 2, 0, 0,
      15, 3, 0, 0, 14, 10, 9, 14, 0, 0, 16, 0, 0, 1, 13, 6);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 37;
         F2 := (F2 + Natural (T2 (K)) * J) mod 37;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 18;
   end Hash;

end CORBA_Repository_Root_Contained_Hash;
